/* This program reapplies the boundary conditions for the
   displacement when the conjugate gradient method is used.
   This is for a finite element program which does analysis
   on an electromagnetic quad element.

                        Updated 12/20/09

    SLFCEM source file
    Version:  1.1
    Copyright (C) 1999-2009 San Le

    The source code contained in this file is released under the
    terms of the GNU Library General Public License.
 */

#include <stddef.h>
#include <stdio.h>
#include <stdlib.h>
#include <math.h>

#if QUADE
#include "../quad/quad_em/qdeconst.h"
#include "../quad/quad_em/qdestruct.h"
#endif
#if TRIE
#include "../tri/tri_em/treconst.h"
#include "../tri/tri_em/trestruct.h"
#endif

int EBoundary ( double *EMedge, BOUND bc )
{
	int i,dum;

        for( i = 0; i < bc.num_edge[0]; ++i )
        {
            dum = bc.edge[i];
            *(EMedge + edof*dum) = 0.0;
        }
	return 1;
}


int VBoundary ( double *Volt, BOUND bc )
{
	int i,dum;

        for( i = 0; i < bc.num_Volt[0]; ++i )
        {
            dum = bc.Volt[i];
            *(Volt + Vndof*dum) = 0.0;
        }
	return 1;
}


