/* 
    This utility function assembles the id array for a finite 
    element program which does analysis on a 4 node quad element.
    It is for eletromagnetism.

		Updated 11/20/09

    SLFCEM source file
    Version:  1.1
    Copyright (C) 1999-2009  San Le 

    The source code contained in this file is released under the
    terms of the GNU Library General Public License.
 
*/

#include <stddef.h>
#include <stdio.h>
#include <stdlib.h>
#include <math.h>

#if QUADE
#include "../quad/quad_em/qdeconst.h"
#include "../quad/quad_em/qdestruct.h"
#endif
#if TRIE
#include "../tri/tri_em/treconst.h"
#include "../tri/tri_em/trestruct.h"
#endif


extern int EMdof, EMneqn, Vdof, Vneqn;

int Vformid( BOUND bc, int *id)
{
/* Assembly of the id array(the matrix which determines
   the degree of feedom by setting fixed nodes = -1) */

	int i, counter;

        counter=0;
        for( i = 0; i < bc.num_Volt[0]; ++i )
	{
           *(id + Vndof*bc.Volt[i]) = -1;
	} 
        for( i = 0; i < Vdof; ++i )
	{
           if( *(id + i) != -1  )
           {
                *(id + i) = counter;
                ++counter;
           }
	}
        Vneqn=counter;
	return 1;
}

int Eformid( BOUND bc, int *id)
{
/* Assembly of the id array(the matrix which determines
   the degree of feedom by setting fixed nodes = -1) */

	int i, counter;

        counter=0;
        for( i = 0; i < bc.num_edge[0]; ++i )
	{
           *(id + edof*bc.edge[i]) = -1;
	} 
        for( i = 0; i < EMdof; ++i )
	{
           if( *(id + i) != -1  )
           {
                *(id + i) = counter;
                ++counter;
           }
	}
        EMneqn=counter;
	return 1;
}

