/*
   This program draws the wireframe of the mesh, but colors the
   lines based on the values of the edge Electric Field values.
   It is only used for modal analysis files.

                  Last Update 1/21/10

    SLFCEM source file
    Version:  1.1
    Copyright (C) 1999-2010  San Le

    The source code contained in this file is released under the
    terms of the GNU Library General Public License.
 
 */

#if WINDOWS
#include <windows.h>
#endif

#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#if QUADE
#include "../quad/quad_em/qdeconst.h"
#include "../quad/quad_em/qdestruct.h"
#endif
#if TRIE
#include "../tri/tri_em/treconst.h"
#include "../tri/tri_em/trestruct.h"
#endif

#include "control.h"

#include <GL/gl.h>
#include <GL/glu.h>
#include <GL/glut.h>

extern GLfloat MeshColor[boxnumber+5][4];
extern int numel, numed, numnp;


void EM_edgedraw( double *coord, double *EMedge, int *EMedge_color,
	int *node_edge_connect )
{

  int i,j, dum, node0, node1;
  double fpointx0, fpointy0, fpointz, fpointx1, fpointy1;
  fpointz = 0.0;
  GLfloat axes_ambuse[] =   { 0.5, 0.0, 0.0, 1.0 };

    MeshColor[0][3] = 1.0;
    MeshColor[1][3] = 1.0;
    MeshColor[2][3] = 1.0;
    MeshColor[3][3] = 1.0;
    MeshColor[4][3] = 1.0;
    MeshColor[5][3] = 1.0;
    MeshColor[6][3] = 1.0;
    MeshColor[7][3] = 1.0;

    glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, axes_ambuse);
    glLineWidth (2.0);
    glBegin(GL_LINES);
/* Draw the EMedge lines */
	for( i = 0; i < numed; ++i)
	{
		dum = *(EMedge_color + i);
		glColor4fv(MeshColor[dum]);
		node0 = *(node_edge_connect + nped*i);
		node1 = *(node_edge_connect + nped*i+1);
		fpointx0 = *(coord+nsd*node0);
		fpointy0 = *(coord+nsd*node0 + 1);
		fpointx1 = *(coord+nsd*node1);
		fpointy1 = *(coord+nsd*node1 + 1);
		glVertex3f( fpointx0, fpointy0, fpointz);
		glVertex3f( fpointx1, fpointy1, fpointz);
	}
    glEnd();
}

