/*
    This utility function allocates the memory for the graphics variables for
    elements which solve Electromagnetic problems.

    In the names "EReGetMemory2_gr" and "EMemory2_gr", the "2" seems unnecessary,
    but they are there because in SLFFEA, there are functions named 
    "ReGetMemory_gr" and "Memory_gr" as well as "ReGetMemory2_gr" and "Memory2_gr".
    These latter 2 functions are similar to "EReGetMemory2_gr" and "EMemory2_gr".

        Updated 1/12/10

    SLFCEM source file
    Version:  1.1
    Copyright (C) 1999-2009  San Le

    The source code contained in this file is released under the
    terms of the GNU Library General Public License.

*/

#include <stdlib.h>
#include <string.h>

#if QUADE
#include "../quad/quad_em/qdeconst.h"
#include "../quad/quad_em/qdestruct.h"
#include "../quad/quadegr/qdestrcgr.h"
#endif
#if TRIE
#include "../tri/tri_em/treconst.h"
#include "../tri/tri_em/trestruct.h"
#include "../tri/triegr/trestrcgr.h"
#endif


extern int input_flag, post_flag;

int EMemory2_gr( XYF **mem_XYF, int sofmXYF )
{
	*mem_XYF=(XYF *)calloc(sofmXYF,sizeof(XYF));
	if(!mem_XYF )
	{
		printf( "failed to allocate memory for XYF doubles\n ");
		exit(1);
	}
	return 1; 
}


int EReGetMemory2_gr( XYF **mem_XYF, int sofmXYF )
{
	*mem_XYF=(XYF *)realloc(*mem_XYF, sofmXYF*sizeof(XYF));
	if(!mem_XYF )
	{
		printf( "failed to allocate memory for XYF doubles\n ");
		exit(1);
	}
	memset(*mem_XYF,0,sofmXYF*sizeof(XYF));

	return 1; 
}

