/*
    This library function reads in additional nodal electric field
    data such as the x and y components and the magnitude of the
    field.

		Updated 1/12/10

    SLFCEM source file
    Version:  1.1
    Copyright (C) 1999-2010  San Le 

    The source code contained in this file is released under the
    terms of the GNU Library General Public License.
 
*/

#include <stddef.h>
#include <stdio.h>
#include <stdlib.h>
#if QUADE
#include "../quad/quad_em/qdeconst.h"
#include "../quad/quad_em/qdestruct.h"
#endif
#if TRIE
#include "../tri/tri_em/treconst.h"
#include "../tri/tri_em/trestruct.h"
#endif

extern int dof, nmat, numel, numnp;

int Ereader_gr( FILE *o1, double *EMnode, double *EMmag)
{
	int i,j,dum;
	char buf[ BUFSIZ ];
	char text;

	fscanf( o1,"\n");
	fgets( buf, BUFSIZ, o1 );

	printf("EMnode for node: ");
	fscanf( o1,"%d",&dum);
	printf( "(%6d)",dum);
	while( dum > -1 )
	{
	   fscanf( o1,"%lf ", (EMnode + ndof*dum));
	   fscanf( o1,"%lf ", (EMnode + ndof*dum + 1));
	   fscanf( o1,"%lf ", (EMmag + Vndof*dum));
	   printf(" %12.5e", *(EMnode + ndof*dum));
	   printf(" %12.5e", *(EMnode + ndof*dum + 1));
	   printf(" %12.5e", *(EMmag + Vndof*dum));
	   fscanf( o1,"\n");
	   printf( "\n");
	   printf("EMnode for node: ");
	   fscanf( o1,"%d",&dum);
	   printf( "(%6d)",dum);
	}

	return 1;
}

