/* This progam converts quad data to triangle
   data by modifying the connectivity.

    Updated 12/5/09

    SLFCEM source file
    Version:  1.1
    Copyright (C) 1999-2009  San Le

    The source code contained in this file is released under the
    terms of the GNU Library General Public License.

 */

#include <stddef.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>

int main()
{
	FILE *o1, *o2;
	int check, i, j, k, connect_el[4], name_length, file_loc;
	int dum, dum1, dum2, dum3, dum4, dum5;
	unsigned short int dum_vec[3];
	char name[30], name2[30], chardum[30], one_char;
	char *ccheck, buf[ BUFSIZ ];
	int numel, numnp, npel4, npel3, nmat, numed, nmode, nsd, epel4, nped;
	double sigma, low_mode;
	int *node_edge_connect, edge_connect_read_flag;
	double fdum, fdum1, fdum2, fdum3, fdum4;

	printf( "\nWhat is the name of the file\n");
	scanf( "%s", name);
	o2 = fopen( name,"r" );

	if(o2 == NULL ) {
		printf("Can't find file %30s\n",name);
		exit(1);
	}

	name_length = strlen(name);
	if( name_length > 20) name_length = 20;

	memset(name2,0,30*sizeof(char));
	ccheck = strncpy(name2, name, name_length);
	if(!ccheck) printf( " Problems with strncpy \n");

	ccheck = strncpy(name2+name_length, "tr", 2);
	if(!ccheck) printf( " Problems with strncpy \n");

	o1 = fopen( name2,"w" );

	fgets( buf, BUFSIZ, o2 );
	npel4 = 4;
	nsd = 2;
	epel4 = 4;
	nped = 2;

	fprintf( o1, "   numed numel numnp nmat nmode sigma low_mode  This is for: %s\n", name2);
	fscanf( o2, "%d %d %d %d %d %lf %lf\n",
		&numed, &numel, &numnp, &nmat, &nmode, &sigma, &low_mode);
	fprintf( o1, "%d %d %d %d %d %lf %lf\n",
		numed, 2*numel, numnp, nmat, nmode, sigma, low_mode);
	fprintf( o1, "matl no., permeability, permittivity, operating fq\n");
	fgets( buf, BUFSIZ, o2 );
	for( i = 0; i < nmat; ++i)
	{
	    fscanf( o2, "%d ", &dum);
	    fprintf( o1, "%3d ", dum);
	    fscanf( o2, " %lf %lf %lf\n", &fdum1, &fdum2, &fdum3);
	    fprintf( o1, " %7.3e %7.3e %7.3e\n", fdum1, fdum2, fdum3);
	}
	fgets( buf, BUFSIZ, o2 );

	file_loc = ftell(o2);

	fscanf( o2,"%d %d %d",&dum, &dum1, &dum2);

/* Check if this data contains the edge connectivity.  */

	edge_connect_read_flag = 1;
	while(( one_char = (unsigned char) fgetc(o2)) != '\n')
	{
		if(one_char != ' ' )
		{
		    ungetc( one_char, o2);
		    fscanf( o2,"%d %d", &dum3, &dum4, &dum5);
		    edge_connect_read_flag = 0;
		    break;
		}
	}

	fseek(o2, file_loc, 0);

	if(edge_connect_read_flag)
	{
	    printf( "\n This file contains edge connectivity.  This will be converted");
	    printf( "\n into a file which does not have edge connectivity.\n");

	    node_edge_connect = (int *)calloc(numed*nped,sizeof(int));
	    
	    for( i = 0; i < numed; ++i )
	    {
		fscanf( o2,"%d ",&dum);
		for( j = 0; j < nped; ++j )
		{
		    fscanf( o2, "%d",(node_edge_connect+nped*dum+j));
		}
		fscanf( o2,"\n");
	    }
	    fgets( buf, BUFSIZ, o2 );
	}

	dum3 = 0;
	fprintf(o1, "el no., node connectivity, matl. no.\n");
	for( i = 0; i < numel; ++i)
	{

/* connectivity */


	    fscanf( o2, "\n");
	    fscanf(o2, "%d", &dum2);
	    for( j = 0; j < npel4; ++j)
	    {
		fscanf(o2, "%d", (connect_el + j));
	    }

	    if(edge_connect_read_flag)
	    {
		for( j = 0; j < epel4; ++j )
		{
		    fscanf( o2, "%d", &dum);
		}
	    }

	    fscanf(o2, "%d", &dum2);

	    fprintf( o1, "%4d", dum3);
	    fprintf( o1, "  %8d", *(connect_el + 0));
	    fprintf( o1, "  %8d", *(connect_el + 1));
	    fprintf( o1, "  %8d", *(connect_el + 2));
	    fprintf( o1, "  %8d\n", 0);
	    ++dum3;

	    fprintf( o1, "%4d", dum3);
	    fprintf( o1, "  %8d", *(connect_el + 2));
	    fprintf( o1, "  %8d", *(connect_el + 3));
	    fprintf( o1, "  %8d", *(connect_el + 0));
	    fprintf( o1, "  %8d\n", 0);
	    ++dum3;

	}

	fscanf( o2, "\n");
	fgets( buf, BUFSIZ, o2 );

	fprintf( o1, "node no., coordinates\n");
	for( i = 0; i < numnp; ++i )
	{
	   fscanf( o2,"%d ",&dum);
	   fprintf( o1, "%5d   ",dum);
	   for( j = 0; j < nsd; ++j )
	   {
		fscanf( o2, "%lf ", &fdum);
		fprintf( o1, "%16.8e   ", fdum);
	   }
	   fscanf( o2,"\n");
	   fprintf( o1, "\n");
	}
	fgets( buf, BUFSIZ, o2 );


	if(nmode)
	{
	    fprintf( o1, "prescribed edge: node1, node2 edge value\n");
	    if(edge_connect_read_flag)
	    {
		fscanf( o2,"%d", &dum2);
		while( dum2 > -1 )
		{
		    fprintf( o1, "%5d ", node_edge_connect[nped*dum2]);
		    fprintf( o1, "%5d ", node_edge_connect[nped*dum2+1]);
		    fscanf( o2,"%lf\n%d", &fdum,
			    &dum2);
		    fprintf( o1, "%14.6e\n", fdum);
		}
	    }
	    else
	    {
		fscanf( o2,"%d", &dum2);
		while( dum2 > -1 )
		{
		    fscanf( o2,"%d", &dum3);
		    fscanf( o2,"%lf\n%d", &fdum,
			    &dum4);
		    fprintf( o1, "%5d ", dum2);
		    fprintf( o1, "%5d ", dum3);
		    fprintf( o1, "%14.6e\n", fdum);

		    dum2 = dum4;
		}
	    }
	}
	if(!nmode)
	{
		fprintf( o1, "prescribed Voltage: node, Voltage value\n");
		fscanf( o2,"%d", &dum2);
		while( dum2 > -1 )
		{
		    fscanf( o2,"%lf\n%d", &fdum,
			    &dum4);
		    fprintf( o1, "%5d ", dum2);
		    fprintf( o1, "%14.6e\n", fdum);

		    dum2 = dum4;
		}
	}

	fscanf( o2,"\n");
	fprintf( o1, "-10\n");
	fgets( buf, BUFSIZ, o2 );

	fprintf( o1, "node with point charge\n");
	fscanf( o2,"%d", &dum2);
	fprintf( o1, "%5d ", dum2);
	while( dum2 > -1 )
	{
		fscanf( o2,"%lf\n%d", &fdum1,
			&dum2);
		fprintf( o1, "%16.8e\n", fdum1);
		fprintf( o1, "%5d ", dum2);
	}
	fprintf( o1, "\n");
	fprintf( o1, "element and gauss pt. with stress and stress vector in xx,yy,xy\n");
	fprintf( o1, "-10\n");

	return 1;
}	

