/*
    This utility function assembles the global matrices for
    Att, Bzz, Bzt, Bzt, and Btt from their respective element
    matrices..  It will likely be for testing purposes only
    using the CLAPACK library which can solve for non-positive
    definite matrices.  

		Updated 9/14/09

    SLFCEM source file
    Version:  1.1
    Copyright (C) 2009  San Le 

    The source code contained in this file is released under the
    terms of the GNU Library General Public License.
 
*/

#include <stddef.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>
#include "qdeconst.h"
#include "qdestruct.h"

extern int analysis_flag, dof, EMdof, neqn, EMneqn, numed, numel, numnp, sof;
extern int LU_decomp_flag, Bzz_LU_decomp_flag, numel_EM, numel_EM_P;

int qdEKglobalassemble( double *AttG, double *BttG, double *BtzG, double *BztG, double *BzzG,
	double *Att, double *Btt, double *Btz, double *Bzt, double *Bzz,
	int *node_edge_connect, int *edge_connect, int *lm)
{
	int i, i1, i2, j, k, dof_el[neqel], EMdof_el[neqel4], sdof_el[npel*nsd];
	int check, counter, node, node1, node2, edge, dum;
	double lamda, mu;
	double fdum, fdum2;

	for( k = 0; k < numel; ++k )
	{

		for( j = 0; j < neqel4; ++j )
		{
			*(EMdof_el+edof*j) = *(lm+neqel4*k+j);
		}

		for( i = 0; i < neqel4; ++i )
		{
		    for( i2 = 0; i2 < neqel4; ++i2 )
		    {
			if( EMdof*(*(EMdof_el+edof*i)) >= 0 && *(EMdof_el+edof*i2) >= 0 )
			{
			    dum = EMneqn*(*(EMdof_el+edof*i)) + *(EMdof_el+edof*i2);
			    /*printf("%4d %4d %4d %4d ppp", dum, EMdof, *(EMdof_el+edof*i), *(EMdof_el+edof*i2));
			    printf("%4d ", dum);*/

			    *(AttG + dum) += *(Att + k*neqlsq16 + neqel4*i + i2 );
			    *(BzzG + dum) += *(Bzz + k*neqlsq16 + neqel4*i + i2 );
			    *(BztG + dum) += *(Bzt + k*neqlsq16 + neqel4*i + i2 );
			    *(BtzG + dum) += *(Btz + k*neqlsq16 + neqel4*i + i2 );
			    *(BttG + dum) += *(Btt + k*neqlsq16 + neqel4*i + i2 );
			}
		    }
		}
#if 0
		for( i2 = 0; i2 < neqel4; ++i2 )
		{
		   for( i1 = 0; i1 < neqel4; ++i1 )
		   {
			printf("%12.8f ",*(Bzz_temp + neqel4*i2 + i1));
		   }
		   printf("\n ");
		}
		printf("\n ");
#endif
	}

	return 1;
}

