/*
    This library function creates the table for the nodal connectivity
    for edges, stored in node_edge_connect, as well as the edge
    connectivity for an element.

		Updated 11/12/09

    SLFCEM source file
    Version:  1.1
    Copyright (C) 2009  San Le 

    The source code contained in this file is released under the
    terms of the GNU Library General Public License.
 
*/

#include <stddef.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "treconst.h"
#include "trestruct.h"

extern int dof, EMdof, nmat, nmode, numed, numel, numnp;

int edge_record( int *, int *, int *, int , int , int , int  );

int tredge( int *connect, int *edge_connect, int *node_edge_connect, int *numed2 )
{
	int i, j, k, dum, dum2, edge_num, new_edge_flag, check;
	int node0, node1, node2, node00, node11;

	*numed2 = 1;
	for( i = 0; i < numel; ++i )
	{
	    node0 = *(connect+npel*i);
	    node1 = *(connect+npel*i + 1);
	    node2 = *(connect+npel*i + 2);

/* For element edge 0 */

	    node11 = node1;
	    node00 = node0;

	    dum = node11;
	    if(node00 > node11)
	    {
		node11 = node00;
		node00 = dum;
	    }

	    edge_num = 0;

/* Check to see if this edge has already been recorded. */

	    check = edge_record( node_edge_connect, edge_connect, numed2,
		i, edge_num, node00, node11 );

/* For element edge 1 */

	    node11 = node2;
	    node00 = node1;

	    dum = node11;
	    if(node00 > node11)
	    {
		node11 = node00;
		node00 = dum;
	    }

	    edge_num = 1;

/* Check to see if this edge has already been recorded. */

	    check = edge_record( node_edge_connect, edge_connect, numed2,
		i, edge_num, node00, node11 );

/* For element edge 2 */

	    node11 = node0;
	    node00 = node2;

	    dum = node11;
	    if(node00 > node11)
	    {
		node11 = node00;
		node00 = dum;
	    }

	    edge_num = 2;

/* Check to see if this edge has already been recorded. */

	    check = edge_record( node_edge_connect, edge_connect, numed2,
		i, edge_num, node00, node11 );
	}

#if 0
	printf("\n zzz \n");
	printf("\n %4d", *numed2 - 1);
/* This is the nodal connectivity for the edges. */
	for( i = 0; i < *numed2 - 1; ++i )
	{
	    printf("\n%4d ", i);
            for( j = 0; j < nped; ++j )
            {
                printf( "%4d ",*(node_edge_connect+nped*i+j));
            }
	}
	printf("\n vvvv \n");
/* This is the edge connectivity for the elements. */
	for( i = 0; i < numel; ++i )
	{
	    printf("%4d", i);
            for( j = 0; j < epel; ++j )
            {
		printf( " %4d", *(connect + npel*i + j));
	    }
	    printf( "     ");
            for( j = 0; j < epel; ++j )
            {
                printf( " %4d",*(edge_connect + epel*i + j));
            }
	    printf( "  %3d\n", 0);
	}
	printf("\n bbb \n");
#endif

	return 1;
}


