/*
    This file contains the structures of the triangle FEM code.

	Updated 1/20/10

    SLFCEM source file
    Version:  1.1
    Copyright (C) 1999-2009  San Le 

    The source code contained in this file is released under the
    terms of the GNU Library General Public License.
 
*/

#include <stddef.h>
#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include "treconst.h"

typedef struct {
	double x, y;
} XYF;

typedef struct {
	int x, y;
} XYI;

typedef struct {
	XYI *num_fix;
	int *num_Volt;
	int *num_edge;
	int *num_charge;
	int *num_EMnode;
	XYI *fix;
	int *Volt;
	int *edge;
	int *charge;
	int *EMnode;
	int *edge_node;   /*  "bc.edge_node" and "bc.EMedge" are needed when           */
	double *EMedge;   /*  there is no edge connectivity in the input file.         */
                          /*  "bc.edge_node" is used to determine the corresponding    */
                          /*  edge.  "bc.EMedge" is needed to temporarily store the    */
                          /*  value of the boundary EMedge before being set to EMedge. */

} BOUND;

typedef struct {
	double er;  /* Relative Permittivity */
	double ur;  /* Relative Permeability */
	double ko;  /* WaveNumber */
	double fq;  /* Operating Frequency */
	double lam; /* WaveLength */
} MATL;

